package genModel

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ ProductRedirectConfModel = (*customProductRedirectConfModel)(nil)

type (
	// ProductRedirectConfModel is an interface to be customized, add more methods here,
	// and implement the added methods in customProductRedirectConfModel.
	ProductRedirectConfModel interface {
		productRedirectConfModel
	}

	customProductRedirectConfModel struct {
		*defaultProductRedirectConfModel
	}
)

// NewProductRedirectConfModel returns a model for the database table.
func NewProductRedirectConfModel(conn sqlx.SqlConn, c cache.CacheConf, opts ...cache.Option) ProductRedirectConfModel {
	return &customProductRedirectConfModel{
		defaultProductRedirectConfModel: newProductRedirectConfModel(conn, c, opts...),
	}
}
